#!/usr/local/bin/jperl
########################################################
# SSM 85 A [ f[^͗pvO
# 2011.1.30
########################################################

my $start = time;

my $KIND = 1;	# Questionnaire A

########################################################
#	Configuration
########################################################

my $BINOUT = 'ssm1985a.bin' ;

%MISS = (
	'NA' ,	-32767,
	'OUT' , 	-32766,
	'BLANK' ,	-32765,
	'GHOST' ,	-32764,
	'YET' , 	-32763,
) ;

my $missmax=-32763;

print "\n[miss]\n" ;
foreach( keys %MISS ){
	print "$_\t$MISS{$_}\n" ;
}

########################################################
#	DATA sǂݏoB
#		[ϐ	]	̗̏p
########################################################

print "\n[var]\n" ;

$nvar = $pointer = $ncard = $i = $[ ;
while( <DATA> ){
		# s͖
	next	if( /^\s*$/ ) ;
	chop;
	if( /^\s*(\S+)\s+(\S+)\s*$/ ) {
		my ( $v, $c ) = ($1, $2);
		# SSM95A0 Ƃ͂APointer`FbN͎gȂB

		
		die( "Less than 1: $_" )  unless 0<$2;
		
		$name[$nvar++] = $1;

		$pointer += ( $width = $2+0 );
		$template[$ncard] .= "a$width" ;

		print "$1\t$ncard\t$2.\n";

		if   ( $width==1 ){ push( @w1 , $1 ); }
		elsif( $width==2 ){ push( @w2 , $1 ); }
		elsif( $width==3 ){ push( @w3 , $1 ); }
		elsif( $width==4 ){ push( @w4 , $1 ); }
		elsif( $width==5 ){ push( @w5 , $1 ); }
		elsif( $v=~/^BLANK/ || $v=~/^null/ ) { }
		else { warn("Width over 5: $_"); }
		
		$nvar[$ncard]++;
	} elsif( m#/# ) {
		$pointer = $[ ;
		++$ncard;
	} else {
		die( "Wrong Statement: $_" ) ;
	}
}

for( $i=$[ ; $i<=$#name ; ++$i ){
	$V{$name[$i]} = $i ;
}


# Aliases
print <<'EOF';


[alias]
A01	Age
A05A	Edu
A09A	MarStat
A09B	MarAge
DANSU	NStage
EOF


print "\n[input]\n" ;

print "nvar\t$nvar\n" ;
print "ncard\t$ncard\n" ;
for( $c=$[ ; $c<$ncard; ++$c ){
	print "nvar of Card $c\t$nvar[$c]\n" ;
}
for( $i=$[; $i<=$#template; ++$i ){
	print "template$i\t$template[$i]\n" ;
}

print "w1\t@w1\n" ;
print "w2\t@w2\n" ;
print "w3\t@w3\n" ;
print "w4\t@w4\n" ;
print "w5\t@w5\n" ;


########################################################
#	ff[^̏
########################################################

open( BINOUT, ">$BINOUT" ) || die( "Cannot open file $BINOUT." );
binmode( BINOUT );

$N=0;
MAINLOOP: while(){
	++$N;
	print STDERR "$N\r" ;
	$#V = $[-1;
	for( $l=$[; $l<$ncard; ++$l ){
		( $card=<> ) || warn( "Record $N is ended at CARD $l." ) ;
		chop( $card );
		push( @V, unpack( $template[$l] , $card ) ) ;
	}
	
		# Check!
#	if( $V[$V{'B21A3'}] eq '9 '){ $V[$V{'B21A3'}]=98 }
	my $i;
	foreach $i( $[ .. $#V  ){
		$V[$i] =~ /\d / && warn( "Value '$V[$i]' ends with space ($N:$i)." ) ;
	}

	for( $i=1; defined( $V{"ID$i"} ) ; ++$i ) {
		( $V[$V{'ID1'}] eq $V[$V{"ID$i"}] ) || warn( qq|Wrong ID$i ($N:$i)| ) ;
		( $KIND == $V[$V{"KIND$i"}] ) || warn( "KIND$i is not $KIND: line $. ($N:$i)" ) ;
		( $V[$V{"BLANK$i"}] =~ /^ +$/ ) || warn( "BLANK$i is not BLANK: line $. ($N:$i)" ) ;
		( $i == $V[$V{"CARD$i"}] ) || warn( "Wrong: CARD$i has wrong value: line $. ($N:$i)" ) ;
	}
	( $V[$V{"null1"}] =~ /^ +$/ ) || warn( "null1 is not BLANK: line $. ($N)" ) ;
	( $V[$V{"null2"}] =~ /^ +$/ ) || warn( "null2 is not BLANK: line $. ($N)" ) ;

	foreach( @w1 ){
		if(    $V[$V{$_}] == 9 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 8 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq ' '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}
	foreach( @w2 ){
		if(    $V[$V{$_}] == 99 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 98 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq '  '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}
	foreach( @w3 ){
		if(    $V[$V{$_}] == 999 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 998 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq '   '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}
	foreach( @w4 ){
		if(    $V[$V{$_}] == 9999 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 9998 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq '    '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}
	foreach( @w5 ){
		if(    $V[$V{$_}] == 99999 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 99998 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq '     '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}

	print BINOUT pack( 's*' , @V ) ;

	last if eof();
}
close( BINOUT );

print "\n[output]\n" ;
print "template\ts*" ;
print "\nrecordsize\t" , 2*@V ;
print "\nN\t" , $N ;
print "\nnvar\t" , $nvar ;
print "\nfilename\t" , $BINOUT;
print "\nfilesize\t" , $filesize = 2*$N*@V;
print "\n\nsec\t" , time()-$start;

$nvar==@V || warn( "Nvar ($nvar) and recordsize/2 (@V) missmatch." ) ;
$realfilesize = (-s $BINOUT);


__END__	#  <DATA> Ŏg
ID1	5
KIND1	1 
A01	2
A02A	2
A02B	2
A03A	2
A03C	2
A03D	2

........... deleted.
Contact TANAKA Sigeto <http://tsigeto.info> to get the data layout.
/
