#!/usr/local/bin/jperl
########################################################
# SSM 85 Ef[^͗pvO
# 2011.1.24
########################################################


my $start = time;

########################################################
#	Configuration
########################################################

my $BINOUT = 'ssm1985f.bin' ;

%MISS = (
	'NA' ,	-32767,
	'OUT' , 	-32766,
	'BLANK' ,	-32765,
	'GHOST' ,	-32764,
	'YET' , 	-32763,
) ;

my $missmax=-32763;

print "\n[miss]\n" ;
foreach( keys %MISS ){
	print "$_\t$MISS{$_}\n" ;
}

########################################################
#	DATA sǂݏoB
#		[ϐ	]	̗̏p
########################################################

print "\n[var]\n" ;

$nvar = $pointer = $ncard = $i = $[ ;
while( <DATA> ){
		# s͖
	next	if( /^\s*$/ ) ;
	chop;
	if( /^\s*(\S+)\s+(\S+)\s*$/ ) {
		# SSM95A0 Ƃ͂APointer`FbN͎gȂB
		die( "Less than 1: $_" )  unless 0<$2;
		
		$name[$nvar++] = $1;

		$pointer += ( $width = $2+0 );
		$template[$ncard] .= "a$width" ;

		print "$1\t$ncard\t$2.\n";

		if   ( $width==1 ){ push( @w1 , $1 ); }
		elsif( $width==2 ){ push( @w2 , $1 ); }
		elsif( $width==3 ){ push( @w3 , $1 ); }
		elsif( $width==4 ){ push( @w4 , $1 ); }
		elsif( $1=~/^BLANK/ || $1=~/^null/ ) {  }
		else { warn("Width over 4: $_"); }

		$nvar[$ncard]++;
	} elsif( m#/# ) {
		$pointer = $[ ;
		++$ncard;
	} else {
		die( "Wrong Statement: $_" ) ;
	}
}

for( $i=$[ ; $i<=$#name ; ++$i ){
	$V{$name[$i]} = $i ;
}

# Aliases
print <<'EOF';


[alias]
F01	Age
F06A	Edu
F10A	MarStat
F10B	MarAge
DANSU	NStage
EOF


print "\n[input]\n" ;

print "nvar\t$nvar\n" ;
print "ncard\t$ncard\n" ;
for( $c=$[ ; $c<$ncard; ++$c ){
	print "nvar of Card $c\t$nvar[$c]\n" ;
}
for( $i=$[; $i<=$#template; ++$i ){
	print "template$i\t$template[$i]\n" ;
}

print "w1\t@w1\n" ;
print "w2\t@w2\n" ;
print "w3\t@w3\n" ;
print "w4\t@w4\n" ;


########################################################
#	ff[^̏
########################################################

open( BINOUT, ">$BINOUT" ) || die( "Cannot open file $BINOUT." );
binmode( BINOUT );

$N=0;
MAINLOOP: while(){
	++$N;
	print STDERR "$N\r" ;
	$#V = $[-1;
	for( $l=$[; $l<$ncard; ++$l ){
		( $card=<> ) || die( "Record $N is ended at CARD $l." ) ;
		#unless( 
		#	$l==$[ 
		#	last MAINLOOP;
		#}
		chop( $card );
		push( @V, unpack( $template[$l] , $card ) ) ;
	}
	
		# Check!
	foreach( @V ){
		/\d +$/ && die( "Value '$_' end with space ($N)." ) ;
	}
	for( $i=1; defined( $V{"IDT$i"} ) ; ++$i ) {
		( $V[$V{'IDT1'}] eq $V[$V{"IDT$i"}] ) || die( qq|Wrong IDT$i ($N:$i)| ) ;
		( $V[$V{'IDP1'}] eq $V[$V{"IDP$i"}] ) || die( qq|Wrong IDP$i ($N:$i)| ) ;
		( 3 == $V[$V{"KIND$i"}] ) || die( "KIND$i is not 3: line $. ($N:$i)" ) ;
		( $V[$V{"BLANK$i"}] =~ /^ +$/ ) || die( "BLANK$i is not BLANK: line $. ($N:$i)" ) ;
		( $i == $V[$V{"CARD$i"}] ) || die( "Wrong: CARD$i has wrong value: line $. ($N:$i)" ) ;
	}
	( $V[$V{"null1"}] =~ /^0+$/ ) || die( "null1 is not zero: line $. ($N)" ) ;
	( $V[$V{"null2"}] =~ /^ +$/ ) || die( "null2 is not BLANK: line $. ($N)" ) ;

	foreach( @w1 ){
		if(    $V[$V{$_}] == 9 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 8 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq ' '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}
	foreach( @w2 ){
		if(    $V[$V{$_}] == 99 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 98 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq '  '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}
	foreach( @w3 ){
		if(    $V[$V{$_}] == 999 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 998 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq '   '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}
	foreach( @w4 ){
		if(    $V[$V{$_}] == 9999 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 9998 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq '    '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}

	#for( $i=1; defined( $V{"IDT$i"} ) ; ++$i ) {
	#	( $MISS{'BLANK'} == $V[$V{"BLANK$i"}] ) || die( "BLANK$i is not BLANK: line $. ($N:$i)" ) ;
	#}
	( '00' == $V[$V{"null1"}] ) || die( "null1 is not zero: line $. ($N)" ) ;

	print BINOUT pack( 's*' , @V ) ;

	last if eof();
}
close( BINOUT );

print "\n[output]\n" ;
print "template\ts*" ;
print "\nrecordsize\t" , 2*@V ;
print "\nN\t" , $N ;
print "\nnvar\t" , $nvar ;
print "\nfilename\t" , $BINOUT;
print "\nfilesize\t" , $filesize = 2*$N*@V;
print "\n\nsec\t" , time()-$start;

$nvar==@V || die( "Nvar ($nvar) and recordsize/2 (@V) missmatch." ) ;
$realfilesize = (-s $BINOUT);
#( $filesize ==  $realfilesize) || die( "Filesize of $BINOUT ($filesize:$realfilesize) missmatch." ) ;


__END__	#  <DATA> Ŏg
IDT1	3
IDP1	2
KIND1	1

F01	2
F02A	2
F02B	2

F03A	2
F03C	2
F03D	2
F03E	3
F03G	1

........... deleted.
Contact TANAKA Sigeto <http://tsigeto.info> to get the data layout.
/

/
