#!/usr/local/bin/jperl
########################################################
# SSM 95 P (Prestige) f[^͗pvO
# 2011/01/30
########################################################


$start = time;

########################################################
#	Configuration
########################################################

$KIND = 3;		# Questionnaire P

$BINOUT = 'ssm1995p.bin' ;

%MISS = (
	'NA' ,	-32767,
	'OUT' , 	-32766,
	'BLANK' ,	-32765,
	'GHOST' ,	-32764,
	'YET' , 	-32763,
) ;

$missmax=-32763;

print "\n[miss]\n" ;
foreach( keys %MISS ){
	print "$_\t$MISS{$_}\n" ;
}

########################################################
#	DATA sǂݏoB
########################################################

print "\n[var]\n" ;

$nvar = $pointer = $ncard = $i = $[ ;
while( <DATA> ){
		# s͖
	next	if( /^\s*$/ ) ;
	chop;
	if( /^\s*(\S+)\s+([^-]+)-?(.*)$/ ) {
		($[-1+$2 == $pointer) || die( "Pointer $pointer unmach: $_" ) ;
		$name[$nvar++] = $1;

		$pointer += ( $width = ('' eq $3) ? 1 : 1+$3-$2 ) ;
		$template[$ncard] .= "a$width" ;

		print "$1\t$ncard\t$2-$3\n";

		if   ( $width==1 ){ push( @w1 , $1 ); }
		elsif( $width==2 ){ push( @w2 , $1 ); }
		elsif( $width==3 ){ push( @w3 , $1 ); }
		elsif( $width==4 ){ push( @w4 , $1 ); }
		else { die("Width over 4: $_"); }

		$nvar[$ncard]++;
	} elsif( m#/# ) {
		$pointer = $[ ;
		++$ncard;
	} else {
		die( "Wrong Statement: $_" ) ;
	}
}

for( $i=$[ ; $i<=$#name ; ++$i ){
	$V{$name[$i]} = $i ;
}

# Aliases
print <<'EOF';


[alias]
Q1_1	Sex
Q1_2A	Age
Q10	Edu
Q11	MarStat
EOF


print "\n[input]\n" ;

print "nvar\t$nvar\n" ;
print "ncard\t$ncard\n" ;
for( $c=$[ ; $c<$ncard; ++$c ){
	print "nvar of Card $c\t$nvar[$c]\n" ;
}
for( $i=$[; $i<=$#template; ++$i ){
	print "template$i\t$template[$i]\n" ;
}

print "w1\t@w1\n" ;
print "w2\t@w2\n" ;
print "w3\t@w3\n" ;
print "w4\t@w4\n" ;


########################################################
#	ff[^̏
########################################################

open( BINOUT, ">$BINOUT" ) || die( "Cannot open file $BINOUT." );
binmode( BINOUT );

$N=0;
MAINLOOP: while(){
	++$N;
	print STDERR "$N\r" ;
	$#V = $[-1;
	for( $l=$[; $l<$ncard; ++$l ){
		( $card=<> ) || die( "Record $N is ended at CARD $l." ) ;
		chop( $card );
		push( @V, unpack( $template[$l] , $card ) ) ;
	}
	
		# Check!
	foreach( @V ){
		/\d +$/ && die( "Value end with space ($N)." ) ;
	}
	for( $i=1; defined( $V{"IDT$i"} ) ; ++$i ) {
		( $V[$V{'IDT1'}] eq $V[$V{"IDT$i"}] ) || die( qq|Wrong IDT$i ($N:$i)| ) ;
		( $V[$V{'IDP1'}] eq $V[$V{"IDP$i"}] ) || die( qq|Wrong IDP$i ($N:$i)| ) ;
		( $KIND == $V[$V{"KIND$i"}] ) || die( "KIND$i is not $KIND: line $. ($N:$i)" ) ;
		( ' ' eq $V[$V{"BLANK$i"}] ) || die( "BLANK$i is not BLANK: line $. ($N:$i)" ) ;
		( $i == $V[$V{"CARD$i"}] ) || die( "Wrong: CARD$i has wrong value: line $. ($N:$i)" ) ;
	}
#	( ' ' eq $V[$V{"null"}] ) || die( "null is not BLANK: line $. ($N)" ) ;

	foreach( @w1 ){
		if(    $V[$V{$_}] == 9 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 8 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq ' '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}
	foreach( @w2 ){
		if(    $V[$V{$_}] == 99 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 98 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq '  '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}
	foreach( @w3 ){
		if(    $V[$V{$_}] == 999 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 998 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq '   '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}
	foreach( @w4 ){
		if(    $V[$V{$_}] == 9999 ) { $V[$V{$_}]=$MISS{'NA'}; }
		elsif( $V[$V{$_}] == 9998 ) { $V[$V{$_}]=$MISS{'OUT'}; }
		elsif( $V[$V{$_}] eq '    '){ $V[$V{$_}]=$MISS{'BLANK'}; }
	}

	for( $i=1; defined( $V{"IDT$i"} ) ; ++$i ) {
		( $MISS{'BLANK'} == $V[$V{"BLANK$i"}] ) || die( "BLANK$i is not BLANK: line $. ($N:$i)" ) ;
	}
#	( $MISS{'BLANK'} == $V[$V{"null"}] ) || die( "null is not BLANK: line $. ($N)" ) ;

	print BINOUT pack( 's*' , @V ) ;

	last if eof();
}
close( BINOUT );

print "\n[output]\n" ;
print "template\ts*" ;
print "\nrecordsize\t" , 2*@V ;
print "\nN\t" , $N ;
print "\nnvar\t" , $nvar ;
print "\nfilename\t" , $BINOUT;
print "\nfilesize\t" , $filesize = 2*$N*@V;
print "\n\nsec\t" , time()-$start;

$nvar==@V || die( "Nvar ($nvar) and recordsize/2 (@V) missmatch." ) ;
$realfilesize = (-s $BINOUT);


__END__	#  <DATA> Ŏg
IDT1	1-3
IDP1	4-5
KIND1	6
BLANK1	7
CARD1	8
Q1_1	9
Q1_2Y	10-11
Q1_2M	12-13

........... deleted.
Contact TANAKA Sigeto <http://tsigeto.info> to get the data layout.
/
